<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Projek</label>

            <b-form-input
              v-model="filter.code"
              disabled
              size="lg"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Projek</label>

            <b-form-input
              v-model="filter.nickname"
              disabled
              size="lg"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Rapat</label>

            <b-form-select
              v-model="filter.meeting_code"
              :options="formattedMeetingOptions"
              size="lg"
              @change="setSubject($event)"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Agenda</label>

            <b-form-input
              v-model="filter.subject"
              disabled
              size="lg"
            ></b-form-input>
          </div>
        </div>
      </div>
    </div>

    <div v-if="filter.code" class="card card-custom p-5 gutter-b">
      <div class="card-header p-0">
        <div class="card-title">
          <h3 class="card-label">
            Informasi Rapat
          </h3>
        </div>
      </div>

      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-2 col-sm-6 col-6 py-3">
            <b>Proyek</b>
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            : {{ currentMeeting.project ? currentMeeting.project.code : null }}
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            <b>Tempat</b>
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            : {{ currentMeeting ? currentMeeting.place : null }}
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            <b>Nomor Rapat</b>
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            : {{ currentMeeting ? currentMeeting.code : null }}
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            <b>Agenda</b>
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            : {{ currentMeeting ? currentMeeting.subject : null }}
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            <b>Tanggal</b>
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            : {{ currentMeeting ? currentMeeting.date : null }}
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            <b>Pimpinan</b>
          </div>

          <div class="col-md-2 col-sm-6 col-6 py-3">
            : {{ currentMeeting ? currentMeeting.leader : null }}
          </div>
        </div>
      </div>
    </div>

    <div v-if="filter.code" class="card card-custom p-5 gutter-b">
      <div class="card-header p-0">
        <div class="card-title">
          <h3 class="card-label">
            Daftar Hadir
          </h3>
        </div>
      </div>

      <div class="card-body p-0">
        <complete-table :data="meeting.attendant" :loading="false">
          <template #header>
            <tr class="text-left">
              <th class="pl-7">Nama</th>
              <th class="pl-7">Instansi</th>
              <th class="pl-7">Email</th>
              <th class="pl-7">Tanda Tangan</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(item, i) in meeting.attendant">
              <tr v-bind:key="i" class="border-0">
                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.name }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.department ? item.department.name : null }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.email }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.signature }}
                  </span>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>

    <div v-if="filter.code" class="card card-custom p-5 gutter-b">
      <div class="card-header p-0">
        <div class="card-title">
          <h3 class="card-label">
            Point MOM
          </h3>
        </div>
      </div>

      <div class="card-body p-0">
        <complete-table :data="meeting.mom_point" :loading="false">
          <template #header>
            <tr class="text-left">
              <th class="pl-7">Point</th>
              <th class="pl-7">Uraian</th>
              <th class="pl-7">Analisa Penyebab</th>
              <th class="pl-7">Deadline</th>
              <th class="pl-7">Status</th>
              <th class="pl-7">PIC</th>
              <th class="pl-7">Respon</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(item, i) in meeting.mom_point">
              <tr v-bind:key="i" class="border-0">
                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.point }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.description }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.cause }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.deadline }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.status }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.pic ? item.pic.name : null }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.response }}
                  </span>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>

    <div v-if="filter.code" class="card card-custom p-5 gutter-b">
      <div class="card-header p-0">
        <div class="card-title">
          <h3 class="card-label">
            Lampiran
          </h3>
        </div>
      </div>

      <div class="card-body p-0">
        <complete-table :data="meeting.file" :loading="false">
          <template #header>
            <tr class="text-left">
              <th class="pl-7">File</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(item, i) in meeting.file">
              <tr v-bind:key="i" class="border-0">
                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.filename }}
                  </span>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "../../../core/services/store/breadcrumbs.module";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import { mapState } from "vuex";
import {
  GET_MEETING,
  GET_MEETING_BY_ID
} from "../../../core/services/store/meeting.module";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";

export default {
  components: { CompleteTable },
  data() {
    return {
      filter: {
        code: null,
        nickname: null,
        meeting_code: null,
        subject: null
      },
      currentMeeting: {
        project: null
      }
    };
  },
  computed: {
    ...mapState({
      meetings: state => state.meeting.meetings?.data,
      meeting: state => state.meeting.meeting?.data
    }),

    formattedMeetingOptions() {
      let meetings = [];

      if (arrayMoreThanOne(this.meetings)) {
        meetings = this.meetings.map(meeting => {
          return {
            value: meeting.code,
            text: meeting.code
          };
        });
      }

      return [{ value: null, text: "Pilih Meeting" }, ...meetings];
    }
  },
  methods: {
    setSubject(value) {
      const meeting = this.meetings?.find(meeting => meeting?.code === value);

      this.filter.subject = meeting?.subject;

      this.filter.code = meeting?.project?.code;

      this.filter.nickname = meeting?.project?.nickname;

      this.currentMeeting = meeting;

      if (meeting?.id) {
        this.$store.dispatch(GET_MEETING_BY_ID, {
          id: meeting?.id
        });
      }
    },

    getMeetings() {
      if (!arrayMoreThanOne(this.meetings)) {
        this.$store.dispatch(GET_MEETING, {
          params: {}
        });
      }
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Report Meeting" }]);

    this.getMeetings();
  }
};
</script>
